/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the TemplatesCloneResult type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TemplatesCloneResult{}

// TemplatesCloneResult struct for TemplatesCloneResult
type TemplatesCloneResult struct {
	NewTemplates []ClonedTemplate `json:"new_templates,omitempty"`
	// Returned when templates were cloned but there are some issues requiring manual intervention
	Issues []string `json:"issues,omitempty"`
	Success bool `json:"success"`
}

// NewTemplatesCloneResult instantiates a new TemplatesCloneResult object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplatesCloneResult(success bool) *TemplatesCloneResult {
	this := TemplatesCloneResult{}
	this.Success = success
	return &this
}

// NewTemplatesCloneResultWithDefaults instantiates a new TemplatesCloneResult object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplatesCloneResultWithDefaults() *TemplatesCloneResult {
	this := TemplatesCloneResult{}
	return &this
}

// GetNewTemplates returns the NewTemplates field value if set, zero value otherwise.
func (o *TemplatesCloneResult) GetNewTemplates() []ClonedTemplate {
	if o == nil || IsNil(o.NewTemplates) {
		var ret []ClonedTemplate
		return ret
	}
	return o.NewTemplates
}

// GetNewTemplatesOk returns a tuple with the NewTemplates field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplatesCloneResult) GetNewTemplatesOk() ([]ClonedTemplate, bool) {
	if o == nil || IsNil(o.NewTemplates) {
		return nil, false
	}
	return o.NewTemplates, true
}

// HasNewTemplates returns a boolean if a field has been set.
func (o *TemplatesCloneResult) HasNewTemplates() bool {
	if o != nil && !IsNil(o.NewTemplates) {
		return true
	}

	return false
}

// SetNewTemplates gets a reference to the given []ClonedTemplate and assigns it to the NewTemplates field.
func (o *TemplatesCloneResult) SetNewTemplates(v []ClonedTemplate) {
	o.NewTemplates = v
}

// GetIssues returns the Issues field value if set, zero value otherwise.
func (o *TemplatesCloneResult) GetIssues() []string {
	if o == nil || IsNil(o.Issues) {
		var ret []string
		return ret
	}
	return o.Issues
}

// GetIssuesOk returns a tuple with the Issues field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplatesCloneResult) GetIssuesOk() ([]string, bool) {
	if o == nil || IsNil(o.Issues) {
		return nil, false
	}
	return o.Issues, true
}

// HasIssues returns a boolean if a field has been set.
func (o *TemplatesCloneResult) HasIssues() bool {
	if o != nil && !IsNil(o.Issues) {
		return true
	}

	return false
}

// SetIssues gets a reference to the given []string and assigns it to the Issues field.
func (o *TemplatesCloneResult) SetIssues(v []string) {
	o.Issues = v
}

// GetSuccess returns the Success field value
func (o *TemplatesCloneResult) GetSuccess() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Success
}

// GetSuccessOk returns a tuple with the Success field value
// and a boolean to check if the value has been set.
func (o *TemplatesCloneResult) GetSuccessOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Success, true
}

// SetSuccess sets field value
func (o *TemplatesCloneResult) SetSuccess(v bool) {
	o.Success = v
}

func (o TemplatesCloneResult) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TemplatesCloneResult) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.NewTemplates) {
		toSerialize["new_templates"] = o.NewTemplates
	}
	if !IsNil(o.Issues) {
		toSerialize["issues"] = o.Issues
	}
	toSerialize["success"] = o.Success
	return toSerialize, nil
}

type NullableTemplatesCloneResult struct {
	value *TemplatesCloneResult
	isSet bool
}

func (v NullableTemplatesCloneResult) Get() *TemplatesCloneResult {
	return v.value
}

func (v *NullableTemplatesCloneResult) Set(val *TemplatesCloneResult) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplatesCloneResult) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplatesCloneResult) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplatesCloneResult(val *TemplatesCloneResult) *NullableTemplatesCloneResult {
	return &NullableTemplatesCloneResult{value: val, isSet: true}
}

func (v NullableTemplatesCloneResult) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplatesCloneResult) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


